"""
    ELEMENTS API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 2
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from elements_sdk.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from elements_sdk.exceptions import ApiAttributeError


def lazy_import():
    from elements_sdk.model.custom_field import CustomField
    from elements_sdk.model.media_root_permission import MediaRootPermission
    from elements_sdk.model.volume_mini import VolumeMini
    globals()['CustomField'] = CustomField
    globals()['MediaRootPermission'] = MediaRootPermission
    globals()['VolumeMini'] = VolumeMini


class MediaRoot(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('name',): {
            'max_length': 255,
            'min_length': 1,
        },
        ('path',): {
            'max_length': 255,
        },
        ('view_mode',): {
            'max_length': 63,
            'min_length': 1,
        },
        ('view_style',): {
            'max_length': 63,
            'min_length': 1,
        },
        ('view_default_tab',): {
            'max_length': 63,
            'min_length': 1,
        },
        ('cover',): {
            'max_length': 255,
        },
        ('name_field',): {
            'max_length': 255,
        },
        ('share_link_duration',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (int,),  # noqa: E501
            'custom_fields': ([CustomField],),  # noqa: E501
            'volume': (VolumeMini,),  # noqa: E501
            'full_path': (str,),  # noqa: E501
            'workflow': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'path': (str,),  # noqa: E501
            'needs_rescan': (bool,),  # noqa: E501
            'view_mode': (str,),  # noqa: E501
            'view_style': (str,),  # noqa: E501
            'view_default_tab': (str,),  # noqa: E501
            'show_tags': (bool,),  # noqa: E501
            'show_comments': (bool,),  # noqa: E501
            'show_locations': (bool,),  # noqa: E501
            'show_custom_fields': (bool,),  # noqa: E501
            'show_ratings': (bool,),  # noqa: E501
            'show_subclips': (bool,),  # noqa: E501
            'show_subtitles': (bool,),  # noqa: E501
            'show_markers': (bool,),  # noqa: E501
            'show_history': (bool,),  # noqa: E501
            'show_ai_metadata': (bool,),  # noqa: E501
            'prefetch_thumbnail_strips': (bool,),  # noqa: E501
            'cover': (str, none_type,),  # noqa: E501
            'name_field': (str, none_type,),  # noqa: E501
            'ai_config': (str,),  # noqa: E501
            'share_comments': (bool,),  # noqa: E501
            'share_link_duration': (int,),  # noqa: E501
            'disable_framestacks': (bool,),  # noqa: E501
            'default_proxy_profile': (int, none_type,),  # noqa: E501
            'cloud_proxy_profile': (int, none_type,),  # noqa: E501
            'ai_connection': (int, none_type,),  # noqa: E501
            'ai_proxy_profile': (int, none_type,),  # noqa: E501
            'resolved_permissions': ([MediaRootPermission],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'custom_fields': 'custom_fields',  # noqa: E501
        'volume': 'volume',  # noqa: E501
        'full_path': 'full_path',  # noqa: E501
        'workflow': 'workflow',  # noqa: E501
        'name': 'name',  # noqa: E501
        'path': 'path',  # noqa: E501
        'needs_rescan': 'needs_rescan',  # noqa: E501
        'view_mode': 'view_mode',  # noqa: E501
        'view_style': 'view_style',  # noqa: E501
        'view_default_tab': 'view_default_tab',  # noqa: E501
        'show_tags': 'show_tags',  # noqa: E501
        'show_comments': 'show_comments',  # noqa: E501
        'show_locations': 'show_locations',  # noqa: E501
        'show_custom_fields': 'show_custom_fields',  # noqa: E501
        'show_ratings': 'show_ratings',  # noqa: E501
        'show_subclips': 'show_subclips',  # noqa: E501
        'show_subtitles': 'show_subtitles',  # noqa: E501
        'show_markers': 'show_markers',  # noqa: E501
        'show_history': 'show_history',  # noqa: E501
        'show_ai_metadata': 'show_ai_metadata',  # noqa: E501
        'prefetch_thumbnail_strips': 'prefetch_thumbnail_strips',  # noqa: E501
        'cover': 'cover',  # noqa: E501
        'name_field': 'name_field',  # noqa: E501
        'ai_config': 'ai_config',  # noqa: E501
        'share_comments': 'share_comments',  # noqa: E501
        'share_link_duration': 'share_link_duration',  # noqa: E501
        'disable_framestacks': 'disable_framestacks',  # noqa: E501
        'default_proxy_profile': 'default_proxy_profile',  # noqa: E501
        'cloud_proxy_profile': 'cloud_proxy_profile',  # noqa: E501
        'ai_connection': 'ai_connection',  # noqa: E501
        'ai_proxy_profile': 'ai_proxy_profile',  # noqa: E501
        'resolved_permissions': 'resolved_permissions',  # noqa: E501
    }

    read_only_vars = {
        'full_path',  # noqa: E501
        'resolved_permissions',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, id, custom_fields, volume, full_path, workflow, name, path, needs_rescan, view_mode, view_style, view_default_tab, show_tags, show_comments, show_locations, show_custom_fields, show_ratings, show_subclips, show_subtitles, show_markers, show_history, show_ai_metadata, prefetch_thumbnail_strips, cover, name_field, ai_config, share_comments, share_link_duration, disable_framestacks, default_proxy_profile, cloud_proxy_profile, ai_connection, ai_proxy_profile, *args, **xkwargs):  # noqa: E501
        """MediaRoot - a model defined in OpenAPI

        Args:
            id (int):
            custom_fields ([CustomField]):
            volume (VolumeMini):
            full_path (str):
            workflow (bool, date, datetime, dict, float, int, list, str, none_type):
            name (str):
            path (str):
            needs_rescan (bool):
            view_mode (str):
            view_style (str):
            view_default_tab (str):
            show_tags (bool):
            show_comments (bool):
            show_locations (bool):
            show_custom_fields (bool):
            show_ratings (bool):
            show_subclips (bool):
            show_subtitles (bool):
            show_markers (bool):
            show_history (bool):
            show_ai_metadata (bool):
            prefetch_thumbnail_strips (bool):
            cover (str, none_type):
            name_field (str, none_type):
            ai_config (str):
            share_comments (bool):
            share_link_duration (int):
            disable_framestacks (bool):
            default_proxy_profile (int, none_type):
            cloud_proxy_profile (int, none_type):
            ai_connection (int, none_type):
            ai_proxy_profile (int, none_type):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            resolved_permissions ([MediaRootPermission]): [optional]  # noqa: E501
        """

        _check_type = xkwargs.pop('_check_type', True)
        _spec_property_naming = xkwargs.pop('_spec_property_naming', False)
        _path_to_item = xkwargs.pop('_path_to_item', ())
        _configuration = xkwargs.pop('_configuration', None)
        _visited_composed_classes = xkwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)


        self.id = id
        self.custom_fields = custom_fields
        self.volume = volume
        self.full_path = full_path
        self.workflow = workflow
        self.name = name
        self.path = path
        self.needs_rescan = needs_rescan
        self.view_mode = view_mode
        self.view_style = view_style
        self.view_default_tab = view_default_tab
        self.show_tags = show_tags
        self.show_comments = show_comments
        self.show_locations = show_locations
        self.show_custom_fields = show_custom_fields
        self.show_ratings = show_ratings
        self.show_subclips = show_subclips
        self.show_subtitles = show_subtitles
        self.show_markers = show_markers
        self.show_history = show_history
        self.show_ai_metadata = show_ai_metadata
        self.prefetch_thumbnail_strips = prefetch_thumbnail_strips
        self.cover = cover
        self.name_field = name_field
        self.ai_config = ai_config
        self.share_comments = share_comments
        self.share_link_duration = share_link_duration
        self.disable_framestacks = disable_framestacks
        self.default_proxy_profile = default_proxy_profile
        self.cloud_proxy_profile = cloud_proxy_profile
        self.ai_connection = ai_connection
        self.ai_proxy_profile = ai_proxy_profile
        for var_name, var_value in xkwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self


    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, id, custom_fields, volume, workflow, name, path, needs_rescan, view_mode, view_style, view_default_tab, show_tags, show_comments, show_locations, show_custom_fields, show_ratings, show_subclips, show_subtitles, show_markers, show_history, show_ai_metadata, prefetch_thumbnail_strips, cover, name_field, ai_config, share_comments, share_link_duration, disable_framestacks, default_proxy_profile, cloud_proxy_profile, ai_connection, ai_proxy_profile, *args, **xkwargs):  # noqa: E501
        """MediaRoot - a model defined in OpenAPI

        Args:
            id (int):
            custom_fields ([CustomField]):
            volume (VolumeMini):
            workflow (bool, date, datetime, dict, float, int, list, str, none_type):
            name (str):
            path (str):
            needs_rescan (bool):
            view_mode (str):
            view_style (str):
            view_default_tab (str):
            show_tags (bool):
            show_comments (bool):
            show_locations (bool):
            show_custom_fields (bool):
            show_ratings (bool):
            show_subclips (bool):
            show_subtitles (bool):
            show_markers (bool):
            show_history (bool):
            show_ai_metadata (bool):
            prefetch_thumbnail_strips (bool):
            cover (str, none_type):
            name_field (str, none_type):
            ai_config (str):
            share_comments (bool):
            share_link_duration (int):
            disable_framestacks (bool):
            default_proxy_profile (int, none_type):
            cloud_proxy_profile (int, none_type):
            ai_connection (int, none_type):
            ai_proxy_profile (int, none_type):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            resolved_permissions ([MediaRootPermission]): [optional]  # noqa: E501
        """

        _check_type = xkwargs.pop('_check_type', True)
        _spec_property_naming = xkwargs.pop('_spec_property_naming', False)
        _path_to_item = xkwargs.pop('_path_to_item', ())
        _configuration = xkwargs.pop('_configuration', None)
        _visited_composed_classes = xkwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)


        self.id = id
        self.custom_fields = custom_fields
        self.volume = volume
        self.workflow = workflow
        self.name = name
        self.path = path
        self.needs_rescan = needs_rescan
        self.view_mode = view_mode
        self.view_style = view_style
        self.view_default_tab = view_default_tab
        self.show_tags = show_tags
        self.show_comments = show_comments
        self.show_locations = show_locations
        self.show_custom_fields = show_custom_fields
        self.show_ratings = show_ratings
        self.show_subclips = show_subclips
        self.show_subtitles = show_subtitles
        self.show_markers = show_markers
        self.show_history = show_history
        self.show_ai_metadata = show_ai_metadata
        self.prefetch_thumbnail_strips = prefetch_thumbnail_strips
        self.cover = cover
        self.name_field = name_field
        self.ai_config = ai_config
        self.share_comments = share_comments
        self.share_link_duration = share_link_duration
        self.disable_framestacks = disable_framestacks
        self.default_proxy_profile = default_proxy_profile
        self.cloud_proxy_profile = cloud_proxy_profile
        self.ai_connection = ai_connection
        self.ai_proxy_profile = ai_proxy_profile
        for var_name, var_value in xkwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")

